# mypy: disable-error-code="misc, override, attr-defined, no-redef, assignment"

import PyFnAttribute as FnAttribute
import PyFnGeolib as FnGeolib
import LookFileBakeAPI.OutputFormatAPI as OutputFormatAPI
import PyFnGeolibProducers
import typing
from LookFileBakeAPI.Exceptions import LookFileBakeException as LookFileBakeException
from PyFnGeolibProducers import GeometryProducer as GeometryProducer
from _typeshed import Incomplete
from typing import Set, Tuple

_CelMatchAttrName: str
g_typeToAttrDict: dict

class DummyProducer:
    def getAttribute(self, name): ...
    def getAttributeNames(self): ...
    def getFirstChild(self): ...
    def getName(self): ...
    def getType(self): ...

class LocationIntervalEvictor(TraversalObserverBase):
    def __init__(self, interval: int = ...) -> None: ...
    def advance(self, producer: PyFnGeolibProducers.GeometryProducer): ...
    def reset(self): ...
    def __bool__(self) -> bool: ...

class TraversalObserverBase:
    def advance(self, producer: PyFnGeolibProducers.GeometryProducer): ...
    def reset(self): ...

def BuildCollectionsInfoDict(rootProducer): ...
def BuildFullMaterialTree(rootProducer, progressCallback: typing.Optional[typing.Callable] = ...): ...
def BuildSelectedMaterialTree(rootProducer, rootPath, progressCallback: typing.Optional[typing.Callable] = ...): ...
def ConsolidateOverrides(outputDicts: typing.Sequence[dict], progressCallback: typing.Optional[typing.Callable] = ...) -> dict: ...
def ConstraintListDiff(producerA, producerB, rootLocation): ...
def CreateLookFileDirectory(dirPath: str): ...
def DeepAttrDiff(attrA, attrB, outputDict, attrPath: str = ...): ...
def LightListDiff(producerA, producerB, rootLocation): ...
def ScenegraphHierarchyDiff(producerA, producerB, materialsProducer, progressCallback: typing.Optional[typing.Callable] = ..., collectionInfo: Incomplete | None = ..., traversalObserver: Incomplete | None = ...): ...
def ScenegraphImmediateChildDiff(producerA, producerB, materialsProducer): ...
def ScenegraphLocationDiff(producerA, producerB, materialsProducer, materialDict): ...
def WriteLookFile(filePath, outputDictList, materialDict, sharedOverridesDict: Incomplete | None = ..., rootOverrideDict: Incomplete | None = ..., sourceFile: Incomplete | None = ..., sourceAsset: Incomplete | None = ...): ...
def _ScenegraphHierarchyDiff(producerA, producerB, materialsProducer, locationName, outputDict, materialDict, progressCallback: typing.Optional[typing.Callable] = ..., collectionInfo: Incomplete | None = ..., traversalObserver: Incomplete | None = ...): ...
def _WalkMaterialLocation(producer: PyFnGeolibProducers.GeometryProducer, materialDict, progressCallback: typing.Callable): ...
def _WalkMaterialLocations(parentProducer, materialDict, progressCallback: typing.Optional[typing.Callable] = ..., includeTopLevel: bool = ...): ...
